#
# change tag encodings from cp1251 to UTF-8
# uses eyeD3 module to work with id3v2 tags.
# NB: Change in frames.py
# DEFAULT_ENCODING = UTF_8_ENCODING;
# DEFAULT_LANG = "ru";
#
# Author: Alex V. Boreskoff <steps3d@narod.ru>
#

import string, sys, os, codecs, eyeD3

w  = codecs.getdecoder ( "cp1251" )

def	endsWithMp3 ( s ):
	return s [-4:].lower () == ".mp3"

def recode ( s ):	# recode from cp1251 to UTF-8
	s2  = "".join ( [chr(ord(x)) for x in s] )
	return w ( s2 ) [0]

def retagFile ( fileName ):
	print "Retagginng file: ", fileName
	tag=eyeD3.Tag ()
	os.chmod ( fileName, 0600 )	# r/w by owner
	tag.link ( fileName )
	title  = tag.getTitle  ()
	album  = tag.getAlbum  ()
	artist = tag.getArtist ()
	tag.setTitle  ( recode ( title ) )
	tag.setAlbum  ( recode ( album ) )
	tag.setArtist ( recode ( artist ) )
	tag.update ( eyeD3.ID3_V2 )

def retagDir ( dir ):
	for dirName, dirs, files in os.walk ( dir ):
		for f in files:
			if endsWithMp3 ( f ):
				retagFile ( dirName + "/" + f )

#retagFile ( "2.mp3" )

if len ( sys.argv ) < 2:
	print "Usage:\n\t retag folder1 forlder2 ..."
else:
	for i in range ( len ( sys.argv ) - 1 ):
		retagDir ( sys.argv [i+1] )


